# Uses of Class
org.apache.sysds.runtime.instructions.spark.data.IndexedMatrixValue

Packages that use IndexedMatrixValue
Package
Description
org.apache.sysds.runtime.compress
org.apache.sysds.runtime.compress.io
org.apache.sysds.runtime.controlprogram.caching
org.apache.sysds.runtime.instructions.ooc
org.apache.sysds.runtime.instructions.spark.data
org.apache.sysds.runtime.instructions.spark.utils
org.apache.sysds.runtime.io
org.apache.sysds.runtime.matrix.data
org.apache.sysds.runtime.ooc.cache
org.apache.sysds.runtime.ooc.cache.io
org.apache.sysds.runtime.ooc.cache.legacy
org.apache.sysds.runtime.ooc.memory
org.apache.sysds.runtime.ooc.stream
org.apache.sysds.runtime.util

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.compress

Method parameters in org.apache.sysds.runtime.compress with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
CompressedMatrixBlock.`append(MatrixValue v2, ArrayList<IndexedMatrixValue> outlist, int blen, boolean cbind, boolean m2IsLast, int nextNCol)`
`void`
CompressedMatrixBlock.`slice(ArrayList<IndexedMatrixValue> outlist, IndexRange range, int rowCut, int colCut, int blen, int boundaryRlen, int boundaryClen)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.compress.io

Method parameters in org.apache.sysds.runtime.compress.io with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`long`
WriterCompressed.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.controlprogram.caching

Methods in org.apache.sysds.runtime.controlprogram.caching that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`OOCStreamable<IndexedMatrixValue>`
CacheableData.`getStreamable()`
`OOCStream<IndexedMatrixValue>`
CacheableData.`getStreamHandle()`
Method parameters in org.apache.sysds.runtime.controlprogram.caching with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
CacheableData.`setStreamHandle(OOCStreamable<IndexedMatrixValue> q)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.instructions.ooc

Methods in org.apache.sysds.runtime.instructions.ooc that return IndexedMatrixValue
Modifier and Type
Method
Description
`IndexedMatrixValue`
PlaybackStream.`dequeue()`
`static IndexedMatrixValue`
OOCEvictionManager.`get(long streamId, int blockId)`
Get a block from the OOC cache (deserialize on read)
Methods in org.apache.sysds.runtime.instructions.ooc that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`OOCStream.QueueCallback<IndexedMatrixValue>`
PlaybackStream.`dequeueCB()`
`OOCStream.QueueCallback<IndexedMatrixValue>`
CachingStream.`findCached(MatrixIndexes idx)`
`CompletableFuture<OOCStream.QueueCallback<IndexedMatrixValue>>`
CachingStream.`get(int idx)`
`OOCStream<IndexedMatrixValue>`
CachingStream.`getReadStream()`
`OOCStream<IndexedMatrixValue>`
PlaybackStream.`getReadStream()`
`OOCStream<IndexedMatrixValue>`
CachingStream.`getWriteStream()`
`OOCStream<IndexedMatrixValue>`
PlaybackStream.`getWriteStream()`
`OOCStream.QueueCallback<IndexedMatrixValue>`
CachingStream.`peekCached(MatrixIndexes idx)`
Finds a cached item without counting it as a consumption.
Methods in org.apache.sysds.runtime.instructions.ooc with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
PlaybackStream.`enqueue(IndexedMatrixValue t)`
`static void`
OOCEvictionManager.`put(long streamId, int blockId, IndexedMatrixValue value)`
Store a block in the OOC cache (serialize once)
Method parameters in org.apache.sysds.runtime.instructions.ooc with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
PlaybackStream.`enqueue(OOCStream.QueueCallback<IndexedMatrixValue> callback)`
`void`
CachingStream.`findCachedAsync(MatrixIndexes idx, Consumer<OOCStream.QueueCallback<IndexedMatrixValue>> callback)`
`static void`
TeeOOCInstruction.`incrRef(OOCStreamable<IndexedMatrixValue> stream, int incr)`
Increments the reference counter of a stream by the set amount.
`void`
CachingStream.`peekCachedAsync(MatrixIndexes idx, Consumer<OOCStream.QueueCallback<IndexedMatrixValue>> callback)`
Finds a cached item asynchronously without counting it as a consumption.
`void`
CachingStream.`setSubscriber(Consumer<OOCStream.QueueCallback<IndexedMatrixValue>> subscriber, boolean incrConsumers)`
`void`
PlaybackStream.`setSubscriber(Consumer<OOCStream.QueueCallback<IndexedMatrixValue>> subscriber)`
Constructor parameters in org.apache.sysds.runtime.instructions.ooc with type arguments of type IndexedMatrixValue
Modifier
Constructor
Description
``
`CachingStream(OOCStream<IndexedMatrixValue> source)`
``
`CachingStream(OOCStream<IndexedMatrixValue> source, long streamId)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.instructions.spark.data

Methods in org.apache.sysds.runtime.instructions.spark.data that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`List<IndexedMatrixValue>`
ReblockBuffer.`flushBufferToBinaryBlocks()`
Constructors in org.apache.sysds.runtime.instructions.spark.data with parameters of type IndexedMatrixValue
Modifier
Constructor
Description
``
`IndexedMatrixValue(IndexedMatrixValue that)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.instructions.spark.utils

Methods in org.apache.sysds.runtime.instructions.spark.utils that return IndexedMatrixValue
Modifier and Type
Method
Description
`static IndexedMatrixValue`
SparkUtils.`toIndexedMatrixBlock(MatrixIndexes ix, MatrixBlock mb)`
`static IndexedMatrixValue`
SparkUtils.`toIndexedMatrixBlock(scala.Tuple2<MatrixIndexes,MatrixBlock> in)`
Methods in org.apache.sysds.runtime.instructions.spark.utils with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`static scala.Tuple2<MatrixIndexes,MatrixBlock>`
SparkUtils.`fromIndexedMatrixBlock(IndexedMatrixValue in)`
`static Pair<MatrixIndexes,MatrixBlock>`
SparkUtils.`fromIndexedMatrixBlockToPair(IndexedMatrixValue in)`
Method parameters in org.apache.sysds.runtime.instructions.spark.utils with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`static List<scala.Tuple2<MatrixIndexes,MatrixBlock>>`
SparkUtils.`fromIndexedMatrixBlock(List<IndexedMatrixValue> in)`
`static List<Pair<MatrixIndexes,MatrixBlock>>`
SparkUtils.`fromIndexedMatrixBlockToPair(List<IndexedMatrixValue> in)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.io

Methods in org.apache.sysds.runtime.io that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`ArrayList<IndexedMatrixValue>`
ReaderBinaryBlock.`readIndexedMatrixBlocksFromHDFS(String fname, long rlen, long clen, int blen)`
Method parameters in org.apache.sysds.runtime.io with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`MatrixBlock`
ReaderTextCSVParallel.`readMatrixAsStream(OOCStream<IndexedMatrixValue> outStream, String fname, long rlen, long clen, int blen, long estnnz)`
`abstract long`
MatrixWriter.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
Consumes an out-of-core stream of matrix blocks and writes them to the target output path.
`long`
WriterBinaryBlock.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterBinaryBlockParallel.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterDelta.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterHDF5.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterMatrixMarket.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterTextCell.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterTextCSV.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`
`long`
WriterTextLIBSVM.`writeMatrixFromStream(String fname, OOCStream<IndexedMatrixValue> stream, long rlen, long clen, int blen)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.matrix.data

Methods in org.apache.sysds.runtime.matrix.data that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`static ArrayList<IndexedMatrixValue>`
OperationsOnMatrixValues.`performSlice(IndexedMatrixValue in, IndexRange ixrange, int blen)`
`static List<IndexedMatrixValue>`
LibMatrixReorg.`reshape(IndexedMatrixValue in, DataCharacteristics mcIn, DataCharacteristics mcOut, boolean rowwise, boolean outputEmptyBlocks)`
MR/SPARK reshape interface - for reshape we cannot view blocks independently, and hence, there are different CP and MR interfaces.
Methods in org.apache.sysds.runtime.matrix.data with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`static void`
OperationsOnMatrixValues.`performMapGroupedAggregate(Operator op, IndexedMatrixValue inTarget, MatrixBlock groups, int ngroups, int blen, ArrayList<IndexedMatrixValue> outlist)`
`static void`
OperationsOnMatrixValues.`performShift(IndexedMatrixValue in, IndexRange ixrange, int blen, long rlen, long clen, ArrayList<IndexedMatrixValue> outlist)`
`static ArrayList<IndexedMatrixValue>`
OperationsOnMatrixValues.`performSlice(IndexedMatrixValue in, IndexRange ixrange, int blen)`
`static List<IndexedMatrixValue>`
LibMatrixReorg.`reshape(IndexedMatrixValue in, DataCharacteristics mcIn, DataCharacteristics mcOut, boolean rowwise, boolean outputEmptyBlocks)`
MR/SPARK reshape interface - for reshape we cannot view blocks independently, and hence, there are different CP and MR interfaces.
`static void`
LibMatrixReorg.`rev(IndexedMatrixValue in, long rlen, int blen, ArrayList<IndexedMatrixValue> out)`
`static void`
LibMatrixReorg.`rexpand(IndexedMatrixValue data, double max, boolean rows, boolean cast, boolean ignore, long blen, ArrayList<IndexedMatrixValue> outList)`
MR/Spark rexpand operation (single input, multiple outputs incl empty blocks)
`static void`
LibMatrixReorg.`rmempty(IndexedMatrixValue data, IndexedMatrixValue offset, boolean rmRows, long len, long blen, ArrayList<IndexedMatrixValue> outList)`
MR rmempty interface - for rmempty we cannot view blocks independently, and hence, there are different CP and MR interfaces.
`static void`
LibMatrixReorg.`roll(IndexedMatrixValue in, long rlen, int blen, int shift, ArrayList<IndexedMatrixValue> out)`
Method parameters in org.apache.sysds.runtime.matrix.data with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
MatrixBlock.`append(MatrixValue v2, ArrayList<IndexedMatrixValue> outlist, int blen, boolean cbind, boolean m2IsLast, int nextNCol)`
`void`
MatrixCell.`append(MatrixValue valueIn2, ArrayList<IndexedMatrixValue> outlist, int blen, boolean cbind, boolean m2IsLast, int nextNCol)`
`abstract void`
MatrixValue.`append(MatrixValue valueIn2, ArrayList<IndexedMatrixValue> outlist, int blen, boolean cbind, boolean m2IsLast, int nextNCol)`
`static void`
OperationsOnMatrixValues.`performMapGroupedAggregate(Operator op, IndexedMatrixValue inTarget, MatrixBlock groups, int ngroups, int blen, ArrayList<IndexedMatrixValue> outlist)`
`static void`
OperationsOnMatrixValues.`performShift(IndexedMatrixValue in, IndexRange ixrange, int blen, long rlen, long clen, ArrayList<IndexedMatrixValue> outlist)`
`static void`
LibMatrixReorg.`rev(IndexedMatrixValue in, long rlen, int blen, ArrayList<IndexedMatrixValue> out)`
`static void`
LibMatrixReorg.`rexpand(IndexedMatrixValue data, double max, boolean rows, boolean cast, boolean ignore, long blen, ArrayList<IndexedMatrixValue> outList)`
MR/Spark rexpand operation (single input, multiple outputs incl empty blocks)
`static void`
LibMatrixReorg.`rmempty(IndexedMatrixValue data, IndexedMatrixValue offset, boolean rmRows, long len, long blen, ArrayList<IndexedMatrixValue> outList)`
MR rmempty interface - for rmempty we cannot view blocks independently, and hence, there are different CP and MR interfaces.
`static void`
LibMatrixReorg.`roll(IndexedMatrixValue in, long rlen, int blen, int shift, ArrayList<IndexedMatrixValue> out)`
`void`
MatrixBlock.`slice(ArrayList<IndexedMatrixValue> outlist, IndexRange range, int rowCut, int colCut, int blen, int boundaryRlen, int boundaryClen)`
`void`
MatrixCell.`slice(ArrayList<IndexedMatrixValue> outlist, IndexRange range, int rowCut, int colCut, int blen, int boundaryRlen, int boundaryClen)`
`abstract void`
MatrixValue.`slice(ArrayList<IndexedMatrixValue> outlist, IndexRange range, int rowCut, int colCut, int blen, int boundaryRlen, int boundaryClen)`
Slice out up to 4 matrixBlocks that are separated by the row and col Cuts.

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.ooc.cache

Methods in org.apache.sysds.runtime.ooc.cache that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPin(long streamId, int blockId, IndexedMatrixValue value)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinRaw(BlockKey key, Object data, long size)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinRawSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinSourceBacked(long streamId, int blockId, IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)`
`static CompletableFuture<List<OOCStream.QueueCallback<IndexedMatrixValue>>>`
OOCCacheManager.`requestAnyOf(List<BlockKey> keys, int n, List<BlockKey> sel)`
`static CompletableFuture<OOCStream.QueueCallback<IndexedMatrixValue>>`
OOCCacheManager.`requestBlock(long streamId, long blockId)`
`static CompletableFuture<OOCStream.QueueCallback<IndexedMatrixValue>>`
OOCCacheManager.`requestBlock(BlockKey key)`
`static CompletableFuture<List<OOCStream.QueueCallback<IndexedMatrixValue>>>`
OOCCacheManager.`requestManyBlocks(List<BlockKey> keys)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`tryRequestBlock(long streamId, long blockId)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`tryRequestBlock(BlockKey key)`
`static List<OOCStream.QueueCallback<IndexedMatrixValue>>`
OOCCacheManager.`tryRequestManyBlocks(List<BlockKey> keys)`
Methods in org.apache.sysds.runtime.ooc.cache with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`static void`
OOCCacheManager.`put(long streamId, int blockId, IndexedMatrixValue value)`
Store a block in the OOC cache (serialize once)
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPin(long streamId, int blockId, IndexedMatrixValue value)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinSourceBacked(long streamId, int blockId, IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)`
`static void`
OOCCacheManager.`putSourceBacked(long streamId, int blockId, IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)`
Store a source-backed block in the OOC cache and register its source location.

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.ooc.cache.io

Fields in org.apache.sysds.runtime.ooc.cache.io with type parameters of type IndexedMatrixValue
Modifier and Type
Field
Description
`final OOCStream<IndexedMatrixValue>`
OOCIOHandler.SourceReadRequest.`target`
Constructor parameters in org.apache.sysds.runtime.ooc.cache.io with type arguments of type IndexedMatrixValue
Modifier
Constructor
Description
``
`SourceReadRequest(String path, Types.FileFormat format, long rows, long cols, int blen, long estNnz, long maxBytesInFlight, boolean keepOpenOnLimit, OOCStream<IndexedMatrixValue> target)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.ooc.cache.legacy

Methods in org.apache.sysds.runtime.ooc.cache.legacy that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheScheduler.HandoverHandle.`reclaim()`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.ooc.memory

Methods in org.apache.sysds.runtime.ooc.memory that return IndexedMatrixValue
Modifier and Type
Method
Description
`IndexedMatrixValue`
InMemoryQueueCallback.`get()`
`IndexedMatrixValue`
InMemoryQueueCallback.`takeManagedResultForHandover()`
Methods in org.apache.sysds.runtime.ooc.memory that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`CompletableFuture<OOCStream.QueueCallback<IndexedMatrixValue>>`
CachedAllowance.`get(int index)`
`OOCStream.QueueCallback<IndexedMatrixValue>`
InMemoryQueueCallback.`keepOpen()`
`OOCStream.QueueCallback<IndexedMatrixValue>`
CachedAllowance.`tryGet(int index)`
Constructors in org.apache.sysds.runtime.ooc.memory with parameters of type IndexedMatrixValue
Modifier
Constructor
Description
``
`InMemoryQueueCallback(IndexedMatrixValue result, DMLRuntimeException failure, MemoryAllowance allow, long reservedBytes)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.ooc.stream

Methods in org.apache.sysds.runtime.ooc.stream that return IndexedMatrixValue
Modifier and Type
Method
Description
`IndexedMatrixValue`
SourceOOCStream.SourceGroupCallback.`get()`
Methods in org.apache.sysds.runtime.ooc.stream that return types with arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`OOCStream.QueueCallback<IndexedMatrixValue>`
SourceOOCStream.SourceGroupCallback.`getCallback(int idx)`
`OOCStream<IndexedMatrixValue>`
SourceOOCStreamable.`getReadStream()`
`OOCStream<IndexedMatrixValue>`
SourceOOCStreamable.`getWriteStream()`
`OOCStream.QueueCallback<IndexedMatrixValue>`
SourceOOCStream.SourceGroupCallback.`keepOpen()`
Methods in org.apache.sysds.runtime.ooc.stream with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
SourceOOCStream.`enqueue(IndexedMatrixValue val)`
`void`
SourceOOCStream.`enqueue(IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)`
Method parameters in org.apache.sysds.runtime.ooc.stream with type arguments of type IndexedMatrixValue
Modifier and Type
Method
Description
`void`
SourceOOCStream.`enqueueGroup(List<IndexedMatrixValue> values, OOCIOHandler.GroupSourceBlockDescriptor descriptor)`

## Uses of IndexedMatrixValue in org.apache.sysds.runtime.util

Methods in org.apache.sysds.runtime.util that return IndexedMatrixValue
Modifier and Type
Method
Description
`static IndexedMatrixValue`
UtilFunctions.`createIndexedMatrixBlock(MatrixBlock mb, DataCharacteristics mc, long ix)`
Methods in org.apache.sysds.runtime.util with parameters of type IndexedMatrixValue
Modifier and Type
Method
Description
`static IndexRange`
UtilFunctions.`getSelectedRangeForZeroOut(IndexedMatrixValue in, int blen, IndexRange indexRange)`